from ofxReaderBR.reader.IReaderCashFlow import IReaderCashFlow
from ofxReaderBR.model.CashFlow import CashFlow, CashFlowType

from datetime import datetime


class XMLReaderCashFlow(IReaderCashFlow):
    def read(self, factory, ofx) -> CashFlow:
        cs = CashFlow()

        cs.name = ofx.find('MEMO').text
        cs.value = float(ofx.find('TRNAMT').text)
        dtposted = ofx.find('DTPOSTED').text

        try:
            # YYYYMMDDHHMMSS
            cs.date = datetime.strptime(dtposted[:dtposted.find('[')], '%Y%m%d%H%M%S')
        except:
            cs.date = datetime.strptime(dtposted, '%Y%m%d')

        if (ofx.find('TRNTYPE') == 'CREDIT'):
            cs.flowType = CashFlowType.CREDIT

        return cs
